Index: src/common/mmo.h
===================================================================
--- src/common/mmo.h (revision 23)
+++ src/common/mmo.h (revision 24)
@@ -11,5 +11,5 @@
 
 //Remove/Comment this line to disable sc_data saving. [Skotlex]
-#define ENABLE_SC_SAVING
+#define ENABLE_SC_SAVING 
 //Remove/Comment this line to disable server-side hot-key saving support [Skotlex]
 //Note that newer clients no longer save hotkeys in the registry!
@@ -31,5 +31,5 @@
 #define MAX_FAME 1000000000
 #define MAX_CART 100
-#define MAX_SKILL 1600 //1600 now, for necromancer skills overstepping bounds.
+#define MAX_SKILL 1100 // Bumped to 1100 for new quest skills, will need to further increase one day... [DracoRPG]
 #define GLOBAL_REG_NUM 96
 #define ACCOUNT_REG_NUM 64
@@ -117,5 +117,5 @@
 	IT_AMMO,    //10
 	IT_DELAYCONSUME,//11
-	IT_MAX
+	IT_MAX 
 };
 
@@ -309,5 +309,5 @@
 	int buyer_id;
 	char buyer_name[NAME_LENGTH];
-
+	
 	struct item item;
 	// This data is required for searching, as itemdb is not read by char server
@@ -526,8 +526,7 @@
 	JOB_XMAS,
 	JOB_SUMMER,
-    JOB_ADEPT = 30, // [Brain]
+    JOB_ADEPT = 30, // [Brain] 
     JOB_NECROMANCER, // [Brain]
-    JOB_WARLOCK,
-    
+    JOB_WARLOCK, // Warlock [Brain]
 	JOB_MAX_BASIC,
 
@@ -583,5 +582,4 @@
 	JOB_STAR_GLADIATOR2,
 	JOB_SOUL_LINKER,
-	
 	JOB_MAX,
 };
Index: src/map/atcommand.c
===================================================================
--- src/map/atcommand.c (revision 19)
+++ src/map/atcommand.c (revision 24)
@@ -1263,10 +1263,10 @@
 			{ "supernovice",	23 },
 			{ "gunslinger",	24 },
+			{ "gunner",	24 },
+			{ "ninja",	25 },
 			{ "adept",	30 },//New job classes [Brainstorm]
 			{ "necromancer",	31 },
 			{ "necro",	31 },
 			{ "warlock",	32 },
-			{ "gunner",	24 },
-			{ "ninja",	25 },
 			{ "high novice",	4001 },
 			{ "swordsman high",	4002 },
@@ -7818,15 +7818,13 @@
 {
 	if (sd->state.showsummon) {
-	sd->state.showsummon = 0;
-	clif_displaymessage(fd, "Summon Stats will not be shown.");
-	return 0;
+		sd->state.showsummon = 0;
+		clif_displaymessage(fd, "Summon Stats will not be shown.");
+		return 0;
 	}
 
 	sd->state.showsummon = 1;
-	clif_displaymessage(fd, "Summon Stats are now shown.");
-	return 0;
-}
-
-
+	clif_displaymessage(fd, "Summon Stats is now shown.");
+	return 0;
+}
 /*==========================================
  * Barricade Build
@@ -8592,5 +8590,5 @@
 	{ "killbarricade",     60,     atcommand_barricade_destroy },
 	//Vanaheim Commands
-	{ "showsummon",	 0, atcommand_showsummon}, //Brainstorm
+	{ "showsummon",         0, atcommand_showsummon}, //Brainstorm
 };
 
Index: src/map/itemdb.c
===================================================================
--- src/map/itemdb.c (revision 19)
+++ src/map/itemdb.c (revision 24)
@@ -242,11 +242,12 @@
 	if (jobmask & 1<<JOB_NINJA)
 		bclass[0] |= 1<<MAPID_NINJA;
+//why does it have job masks as 26 27 28? wasnt it 29 30 31 or something?
 	//Custom Classes
 	if (jobmask & 1<<26) // Adept [Brain]
-	bclass[0] |= 1<<MAPID_ADEPT;
+		bclass[0] |= 1<<MAPID_ADEPT;
 	if (jobmask & 1<<27) // Necromancer [Brain]
-	bclass[1] |= 1<<MAPID_ADEPT;
+		bclass[1] |= 1<<MAPID_ADEPT;
 	if (jobmask & 1<<28) // Warlock [Brain]
-	bclass[2] |= 1<<MAPID_ADEPT;
+		bclass[2] |= 1<<MAPID_ADEPT;
 }
 
Index: src/map/script.c
===================================================================
--- src/map/script.c (revision 23)
+++ src/map/script.c (revision 24)
@@ -7486,5 +7486,5 @@
 	int allflag=va_arg(ap,int);
 
-	md->npc_killmonster = 1;
+	md->state.npc_killmonster = 1;
 	
 	if(!allflag){
@@ -7495,5 +7495,5 @@
 			status_kill(bl);
 	}
-	md->npc_killmonster = 0;
+	md->state.npc_killmonster = 0;
 	return 0;
 }
Index: src/map/battle.c
===================================================================
--- src/map/battle.c (revision 19)
+++ src/map/battle.c (revision 24)
@@ -73,5 +73,5 @@
 		return 1;
 	}
-	return 0;
+	return 0;	
 }
 
@@ -123,5 +123,5 @@
 		return 1;
 	}
-	return 0;
+	return 0;	
 }
 
@@ -205,5 +205,5 @@
 		amotion = 1000; //Aegis places a damage-delay cap of 1 sec to non player attacks. [Skotlex]
 	add_timer(tick+amotion, battle_delay_damage_sub, src->id, (int)dat);
-
+	
 	return 0;
 }
@@ -211,5 +211,5 @@
 int battle_attr_ratio(int atk_elem,int def_type, int def_lv)
 {
-
+	
 	if (atk_elem < 0 || atk_elem >= ELE_MAX)
 		return 100;
@@ -222,5 +222,5 @@
 
 /*==========================================
- * Does attribute fix modifiers.
+ * Does attribute fix modifiers. 
  * Added passing of the chars so that the status changes can affect it. [Skotlex]
  * Note: Passing src/target == NULL is perfectly valid, it skips SC_ checks.
@@ -230,8 +230,8 @@
 	struct status_change *sc=NULL, *tsc=NULL;
 	int ratio;
-
+	
 	if (src) sc = status_get_sc(src);
 	if (target) tsc = status_get_sc(target);
-
+	
 	if (atk_elem < 0 || atk_elem >= ELE_MAX)
 		atk_elem = rand()%ELE_MAX;
@@ -277,5 +277,5 @@
 	if (!damage)
 		return 0;
-
+	
 	if( mob_ksprotected(src, bl) )
 		return 0;
@@ -295,5 +295,5 @@
 		if(!damage) return 0;
 	}
-
+	
 	if (skill_num == PA_PRESSURE)
 		return damage; //This skill bypass everything else.
@@ -344,5 +344,5 @@
 			return 0;
 		}
-
+		
 		if(sc->data[SC_DODGE] && !sc->opt1 &&
 			(flag&BF_LONG || sc->data[SC_SPURT])
@@ -372,32 +372,31 @@
 			return 0;
 		}
-
-	//Display red flashing aura effect of Adept Blood Lust [Brain]
-	if(sc->data[SC_LUST] && damage > 0){
-		clif_specialeffect(bl, 548, AREA);
-		if(rand()%100 < 10) clif_specialeffect(bl, 455, AREA); //Red Lightnings, 1/10 attacks will show to prevent spam
-	};
-	//Display blue flashing aura effect of Warlock Overwhelming Evil [Brain]
-	if(sc->data[SC_OVERWHELMING] && damage > 0)
-		clif_specialeffect(bl, 73, AREA);
-
-	// AT-Field [Brainstorm]
-	if(sc->data[SC_ATFIELD] &&
-		rand()%100 < sc->data[SC_ATFIELD]->val2)
-	{	//Blocks all skills.
-		clif_specialeffect(bl, 438, AREA);
-		//Shouldn't end until Breaker's non-weapon part connects.
-		if (skill_num == ASC_BREAKER ||
-		skill_num == LK_SPIRALPIERCE ||
-		skill_num == CG_ARROWVULCAN ||
-		skill_num == SN_SHARPSHOOTING)
-		if (--sc->data[SC_ATFIELD]->val3 <= 0) //We make it work like Safety Wall
-		status_change_end(bl, SC_ATFIELD, -1);
-		return 0;
-	}
-
+		
+		//Display red flashing aura effect of Adept Blood Lust [Brain]
+		if(sc->data[SC_LUST] && damage > 0){
+			clif_specialeffect(bl, 548, AREA);
+			if(rand()%100 < 10) clif_specialeffect(bl, 455, AREA); //Red Lightnings, 1/10 attacks will show to prevent spam
+		};
+		//Display blue flashing aura effect of Warlock Overwhelming Evil [Brain]
+		if(sc->data[SC_OVERWHELMING] && damage > 0)
+			clif_specialeffect(bl, 73, AREA);
+ //AT Field is Irrelevant, I believe.
+		// AT-Field [Brainstorm]
+		if(sc->data[SC_ATFIELD] &&
+			rand()%100 < sc->data[SC_ATFIELD]->val2)
+		{	//Blocks all skills.
+			clif_specialeffect(bl, 438, AREA);
+			//Shouldn't end until Breaker's non-weapon part connects.
+			if (skill_num == ASC_BREAKER ||
+				skill_num == LK_SPIRALPIERCE ||
+				skill_num == CG_ARROWVULCAN ||
+				skill_num == SN_SHARPSHOOTING)
+				if (--sc->data[SC_ATFIELD]->val3 <= 0) //We make it work like Safety Wall
+				status_change_end(bl, SC_ATFIELD, -1);
+			return 0;
+		}
 
 		if (((sce=sc->data[SC_UTSUSEMI]) || sc->data[SC_BUNSINJYUTSU])
-		&&
+		&& 
 			flag&BF_WEAPON && !(skill_get_nk(skill_num)&NK_NO_CARDFIX_ATK))
 		{
@@ -501,9 +500,9 @@
 	}
 	//SC effects from caster side. Currently none.
-/*
+/*	
 	sc = status_get_sc(src);
 	if (sc && sc->count) {
 	}
-*/
+*/	
 	if (battle_config.pk_mode && sd && bl->type == BL_PC && damage)
   	{
@@ -553,10 +552,10 @@
 	if (!damage) //No reductions to make.
 		return 0;
-
+	
 	class_ = status_get_class(bl);
 
 	if (bl->type == BL_MOB)
 		md=(struct mob_data *)bl;
-
+	
 	if(md && md->guardian_data) {
 		if(class_ == MOBID_EMPERIUM && flag&BF_SKILL)
@@ -640,5 +639,6 @@
 
 	if((skill = pc_checkskill(sd,AL_DEMONBANE)) > 0 &&
-		(status->race==RC_UNDEAD || status->race==RC_DEMON) )
+		target->type == BL_MOB && //This bonus doesnt work against players.
+		(battle_check_undead(status->race,status->def_ele) || status->race==RC_DEMON) )
 		damage += (skill*(int)(3+(sd->status.base_level+1)*0.05));	// submitted by orn
 		//damage += (skill * 3);
@@ -649,8 +649,8 @@
 			damage += sd->status.str;
 	}
-
+//AMIDOINITRITE?! V seems okay.	
 	//Warlock Touch of Corruption (Mage-Monster Killer passive skill) [Brainstorm]
 	if((skill = pc_checkskill(sd,WL_CORRUPTION)) > 0 && target->type==BL_MOB )
-	damage += (skill * (status->int_/10));
+		damage += (skill * (status->int_/10));
 
 	if(type == 0)
@@ -737,5 +737,5 @@
 	{	//Mobs/Pets
 		if(flag&4)
-		{
+		{		  
 			atkmin = status->matk_min;
 			atkmax = status->matk_max;
@@ -753,5 +753,5 @@
 		{	//Normal attacks
 			atkmin = status->dex;
-
+			
 			if (sd->equip_index[type] >= 0 && sd->inventory_data[sd->equip_index[type]])
 				atkmin = atkmin*(80 + sd->inventory_data[sd->equip_index[type]]->wlv*20)/100;
@@ -759,5 +759,5 @@
 			if (atkmin > atkmax)
 				atkmin = atkmax;
-
+			
 			if(flag&2 && !(flag&16))
 			{	//Bows
@@ -768,14 +768,14 @@
 		}
 	}
-
+	
 	if (sc && sc->data[SC_MAXIMIZEPOWER])
 		atkmin = atkmax;
-
+	
 	//Weapon Damage calculation
 	if (!(flag&1))
 		damage = (atkmax>atkmin? rand()%(atkmax-atkmin):0)+atkmin;
-	else
+	else 
 		damage = atkmax;
-
+	
 	if (sd)
 	{
@@ -790,5 +790,5 @@
 				sd->right_weapon.atkmods[t_size])/100;
 	}
-
+	
 	//Finally, add baseatk
 	if(flag&4)
@@ -796,5 +796,5 @@
 	else
 		damage += status->batk;
-
+	
 	//rodatazone says that Overrefine bonuses are part of baseatk
 	//Here we also apply the weapon_atk_rate bonus so it is correctly applied on left/right hands.
@@ -823,5 +823,5 @@
 	if (!battle_config.arrow_decrement)
 		return;
-
+	
 	if (skill)
 	{
@@ -891,5 +891,5 @@
 		unsigned idef2 : 1;	//Ignore defense (left weapon)
 		unsigned pdef : 2;	//Pierces defense (Investigate/Ice Pick)
-		unsigned pdef2 : 2;	//1: Use def+def2/100, 2: Use def+def2/50
+		unsigned pdef2 : 2;	//1: Use def+def2/100, 2: Use def+def2/50	
 		unsigned infdef : 1;	//Infinite defense (plants)
 		unsigned arrow : 1;	//Attack is arrow-based
@@ -897,5 +897,5 @@
 		unsigned lh : 1;		//Attack considers left hand (wd.damage2)
 		unsigned weapon : 1; //It's a weapon attack (consider VVS, and all that)
-	}	flag;
+	}	flag;	
 
 	memset(&wd,0,sizeof(wd));
@@ -944,5 +944,5 @@
 	)
 		flag.arrow = 1;
-
+	
 	if(skill_num){
 		wd.flag |= battle_range_type(src, target, skill_num, skill_lv);
@@ -975,5 +975,5 @@
 				wd.type = 0x08;
 				break;
-
+				
 			case GS_GROUNDDRIFT:
 			case KN_SPEARSTAB:
@@ -994,5 +994,5 @@
 	} else //Range for normal attacks.
 		wd.flag |= flag.arrow?BF_LONG:BF_SHORT;
-
+	
 	if (!skill_num && tstatus->flee2 && rand()%1000 < tstatus->flee2)
 	{	//Check for Lucky Dodge
@@ -1046,5 +1046,5 @@
 		//Therefore, we use the old value 3 on cases when an sd gets attacked by a mob
 		cri -= tstatus->luk*(!sd&&tsd?3:2);
-
+		
 		if(tsc)
 		{
@@ -1114,5 +1114,5 @@
 		if(battle_config.agi_penalty_type &&
 			battle_config.agi_penalty_target&target->type)
-		{
+		{	
 			unsigned char attacker_count; //256 max targets should be a sane max
 			attacker_count = unit_counttargeted(target,battle_config.agi_penalty_count_lv);
@@ -1172,5 +1172,5 @@
 			hitrate += hitrate * ( 2 * skill ) / 100;
 
-		hitrate = cap_value(hitrate, battle_config.min_hitrate, battle_config.max_hitrate);
+		hitrate = cap_value(hitrate, battle_config.min_hitrate, battle_config.max_hitrate); 
 
 		if(rand()%100 >= hitrate)
@@ -1323,5 +1323,5 @@
 				)
 				skillratio += sd->random_attack_increase_add;
-
+		
 			ATK_RATE(skillratio);
 		} else {	//Skills
@@ -1329,5 +1329,5 @@
 			{
 				case NC_DEATHHAND: // Necro Death Hand [Brain]
-					skillratio += -25+25*skill_lv;
+					skillratio += -25+25*skill_lv; //I wonder if it will accept that?
 					break;
 				case SM_BASH:
@@ -1335,5 +1335,5 @@
 					break;
 				case SM_MAGNUM:
-					skillratio += 20*skill_lv;
+					skillratio += 20*skill_lv; 
 					break;
 				case MC_MAMMONITE:
@@ -1592,5 +1592,5 @@
 					int k = (wflag-1)/3; //+100% every 3 cells of distance
 					if( k > 2 ) k = 2; // ...but hard-limited to 300%.
-					skillratio += 100 * k;
+					skillratio += 100 * k; 
 					}
 					break;
@@ -1607,11 +1607,4 @@
 					skillratio += 100 *(skill_lv-1);
 					break;
-		/*Mercenary Skills [Brainstorm]
-		case MS_BASH:
-			skillratio += 30*skill_lv;
-			break;
-		case MER_CRASH:
-			skillratio += 10*skill_lv;
-			break;*/
 			}
 
@@ -1675,5 +1668,5 @@
 				break;
 		}
-
+		
 		if(sd)
 		{
@@ -1747,11 +1740,11 @@
 				if(def2 < 1) def2 = 1;
 			}
-			//Vitality reduction from rodatazone: http://rodatazone.simgaming.net/mechanics/substats.php#def
+			//Vitality reduction from rodatazone: http://rodatazone.simgaming.net/mechanics/substats.php#def	
 			if (tsd)	//Sd vit-eq
 			{	//[VIT*0.5] + rnd([VIT*0.3], max([VIT*0.3],[VIT^2/150]-1))
 				vit_def = def2*(def2-15)/150;
 				vit_def = def2/2 + (vit_def>0?rand()%vit_def:0);
-
-				if((sstatus->race==RC_UNDEAD || sstatus->race==RC_DEMON) &&
+				
+				if((battle_check_undead(sstatus->race,sstatus->def_ele) || sstatus->race==RC_DEMON) && //This bonus already doesnt work vs players
 					src->type == BL_MOB && (skill=pc_checkskill(tsd,AL_DP)) > 0)
 					vit_def += skill*(int)(3 +(tsd->status.base_level+1)*0.04);   // submitted by orn
@@ -1761,5 +1754,5 @@
 				vit_def = def2 + (vit_def>0?rand()%vit_def:0);
 			}
-
+			
 			if (battle_config.weapon_defense_type) {
 				vit_def += def1*battle_config.weapon_defense_type;
@@ -1784,5 +1777,5 @@
 		if (sc && skill_num != LK_SPIRALPIERCE)
 		{	//SC skill damages
-			if(sc->data[SC_AURABLADE])
+			if(sc->data[SC_AURABLADE]) 
 				ATK_ADD(20*sc->data[SC_AURABLADE]->val1);
 		}
@@ -1821,5 +1814,5 @@
 			else
 			ARR_FIND(0, 3, i, t_class == sd->hate_mob[i]);
-			if (i < 3 && (skill=pc_checkskill(sd,sg_info[i].anger_id)))
+			if (i < 3 && (skill=pc_checkskill(sd,sg_info[i].anger_id))) 
 			{
 				skillratio = sd->status.base_level + sstatus->dex + sstatus->luk;
@@ -1836,10 +1829,10 @@
 	} //Here ends flag.hit section, the rest of the function applies to both hitting and missing attacks
   	else if(wd.div_ < 0) //Since the attack missed...
-		wd.div_ *= -1;
+		wd.div_ *= -1; 
 
 	if(skill_num == CR_GRANDCROSS || skill_num == NPC_GRANDDARKNESS)
 		return wd; //Enough, rest is not needed.
 
-	if(sd && (skill=pc_checkskill(sd,BS_WEAPONRESEARCH)) > 0)
+	if(sd && (skill=pc_checkskill(sd,BS_WEAPONRESEARCH)) > 0) 
 		ATK_ADD(skill*2);
 
@@ -1883,5 +1876,5 @@
 		{
 			int cardfix = 1000, cardfix_ = 1000;
-			int t_race2 = status_get_race2(target);
+			int t_race2 = status_get_race2(target);	
 			if(sd->state.arrow_atk)
 			{
@@ -1943,5 +1936,5 @@
 				ATK_RATE2(cardfix/10, cardfix_/10);	//What happens if you use right-to-left and there's no right weapon, only left?
 		}
-
+		
 		if (skill_num == CR_SHIELDBOOMERANG || skill_num == PA_SHIELDCHAIN) { //Refine bonus applies after cards and elements.
 			short index= sd->equip_index[EQI_HAND_L];
@@ -1997,5 +1990,5 @@
 		if (flag.lh && (flag.hit || wd.damage2>0))
 			wd.damage2 = 1;
-		if (!(battle_config.skill_min_damage&1))
+		if (!(battle_config.skill_min_damage&1)) 
 			//Do not return if you are supposed to deal greater damage to plants than 1. [Skotlex]
 			return wd;
@@ -2027,5 +2020,5 @@
 	if (sd)
 	{
-		if (!flag.rh && flag.lh)
+		if (!flag.rh && flag.lh) 
 		{	//Move lh damage to the rh
 			wd.damage = wd.damage2;
@@ -2118,5 +2111,5 @@
 					breakrate[1] += sc->data[SC_MELTDOWN]->val3;
 				}
-			}
+			}	
 			if (breakrate[0])
 				skill_break_equip(target, EQP_WEAPON, breakrate[0], BCT_ENEMY);
@@ -2189,5 +2182,5 @@
 	else if (s_ele == -2) //Use status element
 		s_ele = status_get_attack_sc_element(src,status_get_sc(src));
-
+	
 	//Set miscellaneous data that needs be filled
 	if(sd) {
@@ -2199,5 +2192,5 @@
 	ad.flag |= battle_range_type(src, target, skill_num, skill_lv);
 	flag.infdef=(tstatus->mode&MD_PLANT?1:0);
-
+		
 	switch(skill_num)
 	{
@@ -2226,6 +2219,7 @@
 		{	//Calc base damage according to skill
 			case AL_HEAL:
-			case PR_BENEDICTIO:
+			case PR_BENEDICTIO: //Accidentally deleted the :, replaced it. No difference, so dont worry about this.
 			case AD_DARKHEAL: // Adept Dark Heal
+			//Is this a good place for dark heal, i wonder? Seems fine though.
 				ad.damage = skill_calc_heal(src, target, skill_lv)/2;
 				break;
@@ -2346,33 +2340,36 @@
 						skillratio += 100 +100*skill_lv +100*(skill_lv/2);
 						break;
-			case NC_DRAINLIFE: // Necro Drain Life [Brain]
-			skillratio += 25*skill_lv;
-			break;
-			case WL_HELLFIRE: // Warlock Hellfire [Brain]
-			skillratio += 25*skill_lv;
-			break;
-			case WL_SHADOWBURN: // Warlock Shadow Burn [Brain]
-			skillratio += 20*skill_lv;
-			break;
-			case WL_CURSEDOOM: // Warlock Curse of Doom [Brain]
-			skillratio += 400 + 300*skill_lv; //max 20*matk dmg after 60 seconds
-			break;
-			case WL_SEARING: // Warlock Searing Pain [Brain]
-			if(status_get_sc(target)->data[SC_SEARING])
-				skillratio = 10*pc_checkskill(sd,WL_SEARING);//10% * skilllv
-			break; //Else 100% Matk
-			case WL_IMMOLATE: // Warlock Immolate [Brain]
-			if(status_get_sc(target)->data[SC_IMMOLATE])
-				skillratio += 10*pc_checkskill(sd,WL_SEARING);//100% +10 * searing lv
-			else skillratio += -20 + 20*skill_lv;// Else 80% + 20% * skill lv
-			break;
-			case WL_CONFLAGRATE: // Warlock Conflagrate [Brain]
-			skillratio += 100 + 60*skill_lv + //damage bonus from other fire skills
-				10*pc_checkskill(sd,WL_SEARING) + 10*pc_checkskill(sd,WL_IMMOLATE);
-			break;
+						
+//NOTE: All the skills below here did NOT work before, may have been a stupid mistake but this is for reference.
+					case NC_DRAINLIFE: // Necro Drain Life [Brain]
+						skillratio += 25*skill_lv;
+						break;
+					case WL_HELLFIRE: // Warlock Hellfire [Brain]
+						skillratio += 25*skill_lv;
+						break;
+					case WL_SHADOWBURN: // Warlock Shadow Burn [Brain]
+						skillratio += 20*skill_lv;
+						break;
+					case WL_CURSEDOOM: // Warlock Curse of Doom [Brain]
+						skillratio += 400 + 300*skill_lv; //max 20*matk dmg after 60 seconds
+						break;
+					case WL_SEARING: // Warlock Searing Pain [Brain]
+						if(status_get_sc(target)->data[SC_SEARING])
+							skillratio = 10*pc_checkskill(sd,WL_SEARING);//10% * skilllv
+						break; //Else 100% Matk
+					case WL_IMMOLATE: // Warlock Immolate [Brain]
+						if(status_get_sc(target)->data[SC_IMMOLATE])
+							skillratio += 10*pc_checkskill(sd,WL_SEARING);//100% +10 * searing lv
+						else skillratio += -20 + 20*skill_lv;// Else 80% + 20% * skill lv
+						break;
+					case WL_CONFLAGRATE: // Warlock Conflagrate [Brain]
+						skillratio += 100 + 60*skill_lv + //damage bonus from other fire skills
+							10*pc_checkskill(sd,WL_SEARING) + 10*pc_checkskill(sd,WL_IMMOLATE);
+						break;
+
 				}
 
 				MATK_RATE(skillratio);
-
+			
 				//Constant/misc additions from skills
 				if (skill_num == WZ_FIREPILLAR)
@@ -2426,5 +2423,5 @@
 			}
 		}
-
+		
 		if (skill_num == NPC_EARTHQUAKE)
 		{	//Adds atk2 to the damage, should be influenced by number of hits and skill-ratio, but not mdef reductions. [Skotlex]
@@ -2441,14 +2438,12 @@
 		if (!(nk&NK_NO_ELEFIX))
 			ad.damage=battle_attr_fix(src, target, ad.damage, s_ele, tstatus->def_ele, tstatus->ele_lv);
-
-
-	if(skill_num == WL_SHADOWBURN) { // Warlock Shadow Burn [Brain]
-		// This is where we calculate the secondary damage
-		if(ad.damage<1) ad.damage=1;
-		struct Damage md = battle_calc_misc_attack(src,target,skill_num,skill_lv, mflag);
-		if(md.damage<1) md.damage=1; //Changed MD = WD
-		ad.damage += md.damage; // Same as above
-	}
-
+//Take this into account for errors. It looks out of place/outdated but I will not look further into it until I know.
+		if(skill_num == WL_SHADOWBURN) { // Warlock Shadow Burn [Brain]
+			// This is where we calculate the secondary damage
+			if(ad.damage<1) ad.damage=1;
+			struct Damage md = battle_calc_misc_attack(src,target,skill_num,skill_lv, mflag);
+			if(md.damage<1) md.damage=1;
+			ad.damage += md.damage;
+		}
 		if (sd && !(nk&NK_NO_CARDFIX_ATK)) {
 			short t_class = status_get_class(target);
@@ -2505,8 +2500,8 @@
 
 	damage_div_fix(ad.damage, ad.div_);
-
+	
 	if (flag.infdef && ad.damage)
 		ad.damage = ad.damage>0?1:-1;
-
+		
 	ad.damage=battle_calc_damage(src,target,ad.damage,ad.div_,skill_num,skill_lv,ad.flag);
 	if (map_flag_gvg2(target->m))
@@ -2545,8 +2540,8 @@
 
 	nk = skill_get_nk(skill_num);
-
+	
 	sd = BL_CAST(BL_PC, src);
 	tsd = BL_CAST(BL_PC, target);
-
+	
 	if(sd) {
 		sd->state.arrow_atk = 0;
@@ -2579,10 +2574,10 @@
 		if(mflag > 1) //Autocasted Blitz.
 			nk|=NK_SPLASHSPLIT;
-
+		
 		if (skill_num == SN_FALCONASSAULT)
 		{
 			//Div fix of Blitzbeat
 			skill = skill_get_num(HT_BLITZBEAT, 5);
-			damage_div_fix(md.damage, skill);
+			damage_div_fix(md.damage, skill); 
 
 			//Falcon Assault Modifier
@@ -2650,9 +2645,16 @@
 	case NPC_EVILLAND:
 		md.damage = (skill_lv>6)?666:skill_lv*100;
-		//break;
+//Why the hell is this supposed to be above the break?
 	case WL_SHADOWBURN: // Warlock ShadowBurn dark element damage [Brain]
 		s_ele = ELE_DARK;
 		md.damage = ((300 + 20*skill_lv)/100)*((sstatus->int_*(rand()%300+500))/100); //Fixed between min and max matk for now
 		break;
+		
+// Wouldn't this work better?
+
+/*	case WL_SHADOWBURN: // Warlock ShadowBurn dark element damage [Brain]
+		s_ele = ELE_DARK;
+		md.damage = ((300 + 20*skill_lv)/100)*((sstatus->int_*(rand()%300+500))/100); //Fixed between min and max matk for now
+break;*/
 	}
 
@@ -2665,5 +2667,5 @@
 
 	damage_div_fix(md.damage, md.div_);
-
+	
 	if (!(nk&NK_IGNORE_FLEE))
 	{
@@ -2677,7 +2679,7 @@
 				hitrate=80; //Default hitrate
 
-			if(battle_config.agi_penalty_type &&
+			if(battle_config.agi_penalty_type && 
 				battle_config.agi_penalty_target&target->type)
-			{
+			{	
 				unsigned char attacker_count; //256 max targets should be a sane max
 				attacker_count = unit_counttargeted(target,battle_config.agi_penalty_count_lv);
@@ -2814,9 +2816,9 @@
 		if (*damage <= 0) continue;
 		//First and Third iterations: race, other two boss/nonboss state
-		if (i == 0 || i == 2)
+		if (i == 0 || i == 2) 
 			type = race;
 		else
 			type = boss?RC_BOSS:RC_NONBOSS;
-
+		
 		hp = wd->hp_drain[type].value;
 		if (wd->hp_drain[type].rate)
@@ -2841,22 +2843,24 @@
 	if (sd->sp_vanish_rate && rand()%1000 < sd->sp_vanish_rate)
 		status_percent_damage(&sd->bl, tbl, 0, (unsigned char)sd->sp_vanish_per, false);
-// Adept Blood Pact drains 5% damage per hit [FlavioJS/Brain]
+//I don't know about this. But it looks like it fits fine
+	// Adept Blood Pact drains 5% damage per hit [FlavioJS/Brain]
 	if( pc_checkskill(sd, AD_BLOODPACT) > 0 )
-	thp += battle_calc_drain(rdamage,1000,5);
+		thp += battle_calc_drain(rdamage,1000,5);
 
 	// Warlock Soul Steal drains 1%*skilllv damage per hit [Brain]
 	if( pc_checkskill(sd, WL_SOULSTEAL) > 0 )
-	tsp += battle_calc_drain(rdamage,1000,pc_checkskill(sd,WL_SOULSTEAL));
+		tsp += battle_calc_drain(rdamage,1000,pc_checkskill(sd,WL_SOULSTEAL));
 	// Warlock Touch of Corruption burns 1%*skilllv damage as SP per hit [Brain]
-	if( pc_checkskill(sd, WL_CORRUPTION) > 0 ) {
-	int corrupt_sp;
-	corrupt_sp = battle_calc_drain(rdamage,1000,pc_checkskill(sd,WL_CORRUPTION));
-	if(status_damage(NULL, tbl, 0, corrupt_sp, 0, 3))
-		rhp += corrupt_sp;//If SP damage was caused, increase HP damage too
-	}
+	if( pc_checkskill(sd, WL_CORRUPTION) > 0 ) {// This is the opener, whoops lol.
+		int corrupt_sp;
+		corrupt_sp = battle_calc_drain(rdamage,1000,pc_checkskill(sd,WL_CORRUPTION));
+		if(status_damage(NULL, tbl, 0, corrupt_sp, 0, 3))
+			rhp += corrupt_sp;//If SP damage was caused, increase HP damage too
+	}// Where does this bracket open?
+
 	if (!thp && !tsp) return;
 
 	status_heal(&sd->bl, thp, tsp, battle_config.show_hp_sp_drain?3:1);
-
+	
 	if (rhp || rsp)
 		status_zap(tbl, rhp, rsp);
@@ -2894,5 +2898,5 @@
 	if (tsc && !tsc->count)
 		tsc = NULL;
-
+	
 	if (sd)
 	{
@@ -3057,5 +3061,5 @@
 
 	if (tsc) {
-		if (tsc->data[SC_POISONREACT] &&
+		if (tsc->data[SC_POISONREACT] && 
 			(rand()%100 < tsc->data[SC_POISONREACT]->val3
 			|| sstatus->def_ele == ELE_POISON) &&
@@ -3078,12 +3082,12 @@
 	return wd.dmg_lv;
 }
-
+//new battle check code, i speculate it. But it looks like it just calls other races and elements into one big one.
 int battle_check_living(int race,int element)// Living creature check [Brain]
 {
 	if(element == ELE_UNDEAD || race == RC_UNDEAD // Undead element and race check
-	|| race == RC_DEMON		// Demon race check
-	|| race == RC_FORMLESS		// Formless race check
-	|| element == ELE_GHOST){	// Ghost element check
-	return 0;
+		|| race == RC_DEMON			// Demon race check
+		|| race == RC_FORMLESS			// Formless race check
+		|| element == ELE_GHOST){		// Ghost element check
+		return 0;
 	}
 	else {
@@ -3091,5 +3095,4 @@
 	}
 }
-
 int battle_check_undead(int race,int element)
 {
@@ -3219,5 +3222,5 @@
 			break;
 		//All else not specified is an invalid target.
-		default:
+		default:	
 			return 0;
 	}
@@ -3336,6 +3339,6 @@
 			break;
 	}
-
-	if ((flag&BCT_ALL) == BCT_ALL) { //All actually stands for all attackable chars
+	
+	if ((flag&BCT_ALL) == BCT_ALL) { //All actually stands for all attackable chars 
 		if (target->type&BL_CHAR)
 			return 1;
@@ -3345,5 +3348,5 @@
 	if (flag == BCT_NOONE) //Why would someone use this? no clue.
 		return -1;
-
+	
 	if (t_bl == s_bl)
 	{	//No need for further testing.
@@ -3353,5 +3356,5 @@
 		return (flag&state)?1:-1;
 	}
-
+	
 	if (map_flag_vs(m)) { //Check rivalry settings.
 		if (flag&(BCT_PARTY|BCT_ENEMY)) {
@@ -3403,5 +3406,5 @@
 		}
 	}
-
+	
 	if (!state) //If not an enemy, nor a guild, nor party, nor yourself, it's neutral.
 		state = BCT_NEUTRAL;
@@ -3733,5 +3736,5 @@
 	{ "require_glory_guild",                &battle_config.require_glory_guild,             0,      0,      1,              },
 	{ "idle_no_share",                      &battle_config.idle_no_share,                   0,      0,      INT_MAX,        },
-	{ "party_even_share_bonus",             &battle_config.party_even_share_bonus,          0,      0,      INT_MAX,        },
+	{ "party_even_share_bonus",             &battle_config.party_even_share_bonus,          0,      0,      INT_MAX,        }, 
 	{ "delay_battle_damage",                &battle_config.delay_battle_damage,             1,      0,      1,              },
 	{ "hide_woe_damage",                    &battle_config.hide_woe_damage,                 0,      0,      1,              },
@@ -3806,9 +3809,10 @@
 	{ "auction_feeperhour",                 &battle_config.auction_feeperhour,              12000,  0,      INT_MAX,        },
 	{ "auction_maximumprice",               &battle_config.auction_maximumprice,            500000000, 0,   MAX_ZENY,       },
+//battle conf declarations, does this mean we add new lines to battle.conf?
 	//Vanaheim battle settings [Brainstorm]
-	{ "necro_retaliation",		  &battle_config.necro_retaliation,		   1,	  0,	  1,		  },
-	{ "disp_summon_stats",		  &battle_config.disp_summon_stats,		   0,	  0,	  1,		  },
-
+	{ "necro_retaliation",                  &battle_config.necro_retaliation,               1,      0,      1,              },
+	{ "disp_summon_stats",                  &battle_config.disp_summon_stats,               0,      0,      1,              },
 	{ "gm_viewequip_min_lv",                &battle_config.gm_viewequip_min_lv,             0,      0,      99,             },
+	{ "homunculus_auto_vapor",              &battle_config.homunculus_auto_vapor,           0,      0,      1,              },
 };
 
@@ -3854,7 +3858,7 @@
 	battle_config.monster_max_aspd = 2000 - battle_config.monster_max_aspd*10;
 	battle_config.max_aspd = 2000 - battle_config.max_aspd*10;
-	battle_config.max_walk_speed = 100*DEFAULT_WALK_SPEED/battle_config.max_walk_speed;
+	battle_config.max_walk_speed = 100*DEFAULT_WALK_SPEED/battle_config.max_walk_speed;	
 	battle_config.max_cart_weight *= 10;
-
+	
 	if(battle_config.max_def > 100 && !battle_config.weapon_defense_type)	 // added by [Skotlex]
 		battle_config.max_def = 100;
@@ -3862,13 +3866,13 @@
 	if(battle_config.min_hitrate > battle_config.max_hitrate)
 		battle_config.min_hitrate = battle_config.max_hitrate;
-
+		
 	if(battle_config.pet_max_atk1 > battle_config.pet_max_atk2)	//Skotlex
 		battle_config.pet_max_atk1 = battle_config.pet_max_atk2;
-
+	
 	if (battle_config.day_duration && battle_config.day_duration < 60000) // added by [Yor]
 		battle_config.day_duration = 60000;
 	if (battle_config.night_duration && battle_config.night_duration < 60000) // added by [Yor]
 		battle_config.night_duration = 60000;
-
+	
 #ifndef CELL_NOSTACK
 	if (battle_config.cell_stack_limit != 1)
